
#
# This program parses texts and replaces specified names with a user-specified name
# The string 'replace' and list 'remove' methods are not allowed
#
# This implementation uses partition iteratively to find all occurrences of the target name
#

import os

def main():
    books = [e for e in os.listdir('datafiles') if '.DS' not in e]
            
    count = 0

    # map books to target names
    names = {'frankenstein.txt':'Elizabeth', 'heart_of_darkness.txt':'Marlow', 
             'romeo_and_juliet.txt':'Capulet', 'war_of_the_worlds.txt':'Ogilvy'}
    
    # get replacement name from user
    print()
    my_name = input('Enter the replacement name: ')
    print()
    
    # go through all texts in the datafiles directory
    for b in books:
        fn = open('datafiles/' + b, 'r')
        lines = fn.readlines()
        fn.close()
        
        # set target name for this text
        name = names[b]
        
        # loop over lines in text
        for line in lines:
            newline, num = replace_name_in_line(line, name, my_name)
            count += num

            if my_name in newline:
                print(newline)
                print()
                    
    print('Total replacements: {}\n'.format(count))

    
# find occurrences of name and replace with my_name
def replace_name_in_line(line, name, my_name):
    count = 0
    # use partition to find name in line
    t = line.partition(name)
    newline = ''
    
    # repeat for each line until all occurrences replaced
    while t[1] == name:
        # replace name with my_name
        newline = ''.join((t[0], my_name, t[2]))
        t = newline.partition(name)
        count += 1
    return newline, count

    
if __name__ == '__main__':
    main()

